commit 0fc63140232c0ff2fa6a932fb2bd90b0dcf4ba9d
Author: jklowden <jklowden>
Date:   Thu Jun 12 01:00:48 2008 +0000

    small improvements to style, logging, and error messages

diff --git a/ChangeLog b/ChangeLog
index 49e1eb2..bfe1a42 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Sat Jun  7 17:52:24 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* src/dblib/dblib.c src/dblib/rpc.c src/dblib/unittests/rpc.c
+	* src/tds/convert.c
+	- small improvements to style, logging, and error messages
+
 Thu Jun 05 18:21:25 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c:
 	- fix cursor6 test
@@ -33,7 +38,7 @@ Tue May 27 10:00:44 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h: fix possible buffer overflow
 
 Mon May 26 15:56:10 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
-	(monstly from Coverity reports)
+	(mostly from Coverity reports)
 	* include/tdsbytes.h: remove warning
 	* src/apps/tsql.c src/dblib/bcp.c src/dblib/dblib.c:
 	- remove some leaks
@@ -333,4 +338,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2532 2008/06/05 16:21:50 freddy77 Exp $
+$Id: ChangeLog,v 1.2533 2008/06/12 01:00:48 jklowden Exp $
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 0d40af7..96d7de4 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.324 2008/05/26 13:56:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.325 2008/06/12 01:00:48 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -1258,7 +1258,7 @@ dbcmd(DBPROCESS * dbproc, const char *cmdstring)
 	if (dbproc->dbbufsz == 0) {
 		dbproc->dbbuf = malloc(strlen(cmdstring) + 1);
 		if (dbproc->dbbuf == NULL) {
-			dbperror(NULL, SYBEMEM, errno);
+			dbperror(dbproc, SYBEMEM, errno);
 			return FAIL;
 		}
 		strcpy((char *) dbproc->dbbuf, cmdstring);
@@ -1266,7 +1266,7 @@ dbcmd(DBPROCESS * dbproc, const char *cmdstring)
 	} else {
 		newsz = strlen(cmdstring) + dbproc->dbbufsz;
 		if ((p = realloc(dbproc->dbbuf, newsz)) == NULL) {
-			dbperror(NULL, SYBEMEM, errno);
+			dbperror(dbproc, SYBEMEM, errno);
 			return FAIL;
 		}
 		dbproc->dbbuf = (unsigned char *) p;
@@ -1335,7 +1335,7 @@ dbuse(DBPROCESS * dbproc, const char *name)
 	/* quote name */
 	query = malloc(tds_quote_id(dbproc->tds_socket, NULL, name, -1) + 6);
 	if (!query) {
-		dbperror(NULL, SYBEMEM, errno);
+		dbperror(dbproc, SYBEMEM, errno);
 		return FAIL;
 	}
 	strcpy(query, "use ");
@@ -2715,7 +2715,7 @@ dbclrbuf(DBPROCESS * dbproc, DBINT n)
 DBBOOL
 dbwillconvert(int srctype, int desttype)
 {
-	tdsdump_log(TDS_DBG_FUNC, "dbwillconvert(%d, %d)\n", srctype, desttype);
+	tdsdump_log(TDS_DBG_FUNC, "dbwillconvert(%s, %s)\n", tds_prdatatype(srctype), tds_prdatatype(desttype));
 	return tds_willconvert(srctype, desttype);
 }
 
@@ -3270,7 +3270,7 @@ dbprrow(DBPROCESS * dbproc)
 
 			if (col_printlens == NULL) {
 				if ((col_printlens = calloc(resinfo->num_cols, sizeof(TDS_SMALLINT))) == NULL) {
-					dbperror(NULL, SYBEMEM, errno);
+					dbperror(dbproc, SYBEMEM, errno);
 					return FAIL;
 				}
 			}
@@ -4718,7 +4718,7 @@ dbbylist(DBPROCESS * dbproc, int computeid, int *size)
 		unsigned int n;
 		TDS_TINYINT *p = malloc(sizeof(info->bycolumns[0]) + info->by_cols);
 		if (!p) {
-			dbperror(NULL, SYBEMEM, errno);
+			dbperror(dbproc, SYBEMEM, errno);
 			return NULL;
 		}
 		for (n = 0; n < info->by_cols; ++n)
diff --git a/src/dblib/rpc.c b/src/dblib/rpc.c
index 525c934..4b26de4 100644
--- a/src/dblib/rpc.c
+++ b/src/dblib/rpc.c
@@ -54,7 +54,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: rpc.c,v 1.64 2007/12/06 18:32:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: rpc.c,v 1.65 2008/06/12 01:00:48 jklowden Exp $");
 
 static void rpc_clear(DBREMOTE_PROC * rpc);
 static void param_clear(DBREMOTE_PROC_PARAM * pparam);
@@ -86,6 +86,11 @@ dbrpcinit(DBPROCESS * dbproc, char *rpcname, DBSMALLINT options)
 	DBPERROR_RETURN(IS_TDSDEAD(dbproc->tds_socket), SYBEDDNE);
 	CHECK_NULP(rpcname, "dbrpcinit", 2, FAIL);
 
+	/*
+	 * TODO: adhere to docs.  Only Microsoft supports DBRPCRESET.  They say:
+	 * "Cancels a single stored procedure or a batch of stored procedures. 
+	 *  If rpcname is specified, that new stored procedure is initialized after the cancellation is complete."
+	 */
 	if (options & DBRPCRESET) {
 		rpc_clear(dbproc->rpc);
 		dbproc->rpc = NULL;
@@ -99,27 +104,27 @@ dbrpcinit(DBPROCESS * dbproc, char *rpcname, DBSMALLINT options)
 	/* all other options except DBRPCRECOMPILE are invalid */
 	DBPERROR_RETURN3(options, SYBEIPV, (int) options, "options", "dbrpcinit");
 
-	/* to allocate, first find a free node */
+	/* find a free node */
 	for (rpc = &dbproc->rpc; *rpc != NULL; rpc = &(*rpc)->next) {
 		/* check existing nodes for name match (there shouldn't be one) */
-		if (!(*rpc)->name)
-			return FAIL;
-		if (strcmp((*rpc)->name, rpcname) == 0)
-			return FAIL /* dbrpcsend should free pointer */ ;
+		if ((*rpc)->name == NULL  || strcmp((*rpc)->name, rpcname) == 0) {
+			tdsdump_log(TDS_DBG_INFO1, "error: dbrpcinit called twice for procedure \"%s\"\n", rpcname);
+			return FAIL; 
+		}
 	}
 
 	/* rpc now contains the address of the dbproc's first empty (null) DBREMOTE_PROC* */
 
 	/* allocate */
-	*rpc = (DBREMOTE_PROC *) malloc(sizeof(DBREMOTE_PROC));
-	if (*rpc == NULL)
+	if ((*rpc = (DBREMOTE_PROC *) calloc(1, sizeof(DBREMOTE_PROC))) == NULL) {
+		dbperror(dbproc, SYBEMEM, errno);
 		return FAIL;
-	memset(*rpc, 0, sizeof(DBREMOTE_PROC));
+	}
 
-	(*rpc)->name = strdup(rpcname);
-	if ((*rpc)->name == NULL) {
+	if (((*rpc)->name = strdup(rpcname)) == NULL) {
 		free(*rpc);
 		*rpc = NULL;
+		dbperror(dbproc, SYBEMEM, errno);
 		return FAIL;
 	}
 
@@ -143,7 +148,8 @@ dbrpcinit(DBPROCESS * dbproc, char *rpcname, DBSMALLINT options)
  *        If not used, parameters will be passed in order instead of by name. 
  * \param status must be DBRPCRETURN, if this parameter is a return parameter, else 0. 
  * \param type datatype of the value parameter e.g., SYBINT4, SYBCHAR.
- * \param maxlen Maximum output size of the parameter's value to be returned by the stored procedure, usually the size of your host variable. 
+ * \param maxlen Maximum output size of the parameter's value to be returned by the stored procedure, 
+ *  	  usually the size of your host variable. 
  *        Fixed-length datatypes take -1 (NULL or not).  
  *        Non-OUTPUT parameters also use -1.  
  *	   Use 0 to send a NULL value for a variable length datatype.  
diff --git a/src/dblib/unittests/rpc.c b/src/dblib/unittests/rpc.c
index e9e8bb4..82deff0 100644
--- a/src/dblib/unittests/rpc.c
+++ b/src/dblib/unittests/rpc.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: rpc.c,v 1.32 2007/12/04 02:06:38 jklowden Exp $";
+static char software_version[] = "$Id: rpc.c,v 1.33 2008/06/12 01:00:48 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char cmd[4096];
@@ -27,6 +27,7 @@ static const char procedure_sql[] =
 			", @nullout int OUTPUT\n"
 			", @nrows int OUTPUT \n"
 			", @c varchar(20)\n"
+			", @nv nvarchar(20) = N'hello'\n"
 		"AS \n"
 		"BEGIN \n"
 			"select @null_input = max(convert(varchar(30), name)) from systypes \n"
@@ -35,7 +36,7 @@ static const char procedure_sql[] =
 			"select distinct convert(varchar(30), name) as 'type'  from systypes \n"
 				"where name in ('int', 'char', 'text') \n"
 			"select @nrows = @@rowcount \n"
-			"select distinct convert(varchar(30), name) as name  from sysobjects where type = 'S' \n"
+			"select distinct @nv as '@nv', convert(varchar(30), name) as name  from sysobjects where type = 'S' \n"
 			"return 42 \n"
 		"END \n";
 
@@ -123,6 +124,13 @@ ignore_err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char
 	return erc;
 }
 
+int 
+colwidth( DBPROCESS * dbproc, int icol ) 
+{
+	int width = dbwillconvert(dbcoltype(dbproc, icol), SYBCHAR);
+	return 255 == width? dbcollen(dbproc, icol) : width;
+}
+
 int
 main(int argc, char **argv)
 {
@@ -130,29 +138,28 @@ main(int argc, char **argv)
 	DBPROCESS *dbproc;
 	RETPARAM save_param;
 	
-	int i, r;
 	char teststr[1024];
-	int failed = 0;
 	char *retname = NULL;
-	int rettype = 0, retlen = 0;
-	int return_status = 0;
+	int i, failed = 0;
+	int rettype = 0, retlen = 0, return_status = 0;
 	char proc[] = "#t0022", 
 	     param0[] = "@null_input", 
 	     param1[] = "@first_type", 
 	     param2[] = "@nullout",
 	     param3[] = "@nrows",
-	     param4[] = "@c";
+	     param4[] = "@c",
+	     param5[] = "@nv";
 	char *proc_name = proc;
 
 	char param_data1[64];
-	int param_data2;
-	int param_data3;
+	int param_data2, param_data3;
+	int num_resultset = 0, num_empty_resultset = 0;
+
+	static const char dashes30[] = "------------------------------";
+	static const char  *dashes5 = dashes30 + (sizeof(dashes30) - 5), 
+			  *dashes15 = dashes30 + (sizeof(dashes30) - 15);
+
 	RETCODE erc, row_code;
-	int num_resultset = 0;
-	int num_empty_resultset = 0;
-	static const char dashes5[]  = "-----", 
-			  dashes15[] = "---------------", 
-			  dashes30[] = "------------------------------";
 
 	set_malloc_options();
 	
@@ -212,35 +219,35 @@ main(int argc, char **argv)
 	printf("executing dbrpcinit\n");
 	erc = dbrpcinit(dbproc, proc_name, 0);	/* no options */
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcinit\n");
+		fprintf(stderr, "Failed line %d: dbrpcinit\n", __LINE__);
 		failed = 1;
 	}
 
 	printf("executing dbrpcparam\n");
 	erc = dbrpcparam(dbproc, param0, DBRPCRETURN, SYBCHAR, /*maxlen= */ -1, /* datlen= */ 0, NULL);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcparam\n");
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
 		failed = 1;
 	}
 
 	printf("executing dbrpcparam\n");
 	erc = dbrpcparam(dbproc, param1, DBRPCRETURN, SYBCHAR, /*maxlen= */ sizeof(param_data1), /* datlen= */ 0, (BYTE *) & param_data1);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcparam\n");
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
 		failed = 1;
 	}
 
 	printf("executing dbrpcparam\n");
 	erc = dbrpcparam(dbproc, param2, DBRPCRETURN, SYBINT4, /*maxlen= */ -1, /* datalen= */ 0, (BYTE *) & param_data2);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcparam\n");
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
 		failed = 1;
 	}
 
 	printf("executing dbrpcparam\n");
 	erc = dbrpcparam(dbproc, param3, DBRPCRETURN, SYBINT4, /*maxlen= */ -1, /* datalen= */ -1, (BYTE *) & param_data3);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcparam\n");
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
 		failed = 1;
 	}
 
@@ -248,7 +255,14 @@ main(int argc, char **argv)
 	printf("executing dbrpcparam\n");
 	erc = dbrpcparam(dbproc, param4, 0, SYBVARCHAR, /*maxlen= */ 0, /* datalen= */ 0, NULL);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcparam\n");
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
+		failed = 1;
+	}
+
+	printf("executing dbrpcparam\n");
+	erc = dbrpcparam(dbproc, param5, 0, SYBVARCHAR, /*maxlen= */ -1, /* datalen= */ 2, &"OK:");
+	if (erc == FAIL) {
+		fprintf(stderr, "Failed line %d: dbrpcparam\n", __LINE__);
 		failed = 1;
 	}
 
@@ -256,7 +270,7 @@ main(int argc, char **argv)
 	param_data3 = 0x11223344;
 	erc = dbrpcsend(dbproc);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbrpcsend\n");
+		fprintf(stderr, "Failed line %d: dbrpcsend\n", __LINE__);
 		exit(1);
 	}
 
@@ -264,27 +278,47 @@ main(int argc, char **argv)
 	printf("executing dbsqlok\n");
 	erc = dbsqlok(dbproc);
 	if (erc == FAIL) {
-		fprintf(stderr, "Failed: dbsqlok\n");
+		fprintf(stderr, "Failed line %d: dbsqlok\n", __LINE__);
 		exit(1);
 	}
 
 	add_bread_crumb();
 
 	/* retrieve outputs per usual */
-	r = 0;
+	printf("fetching results\n");
 	while ((erc = dbresults(dbproc)) != NO_MORE_RESULTS) {
+		printf("fetched resultset %d %s:\n", 1+num_resultset, erc==SUCCEED? "successfully":"unsuccessfully");
 		if (erc == SUCCEED) { 
-			const int ncols = dbnumcols(dbproc);
-			int empty_resultset = 1;
+			const int ncol = dbnumcols(dbproc);
+			int empty_resultset = 1, c;
+			enum {buflen=1024, nbuf=5};
+			char bound_buffers[nbuf][buflen] = { "one", "two", "three", "four", "five" };
+
 			++num_resultset;
-			printf("bound 1 of %d columns ('%s') in result %d.\n", ncols, dbcolname(dbproc, 1), ++r);
-			dbbind(dbproc, 1, STRINGBIND, 0, (BYTE *) teststr);
 			
-			printf("\t%s\n\t-----------\n", dbcolname(dbproc, 1));
+			for( c=0; c < ncol && c < nbuf; c++ ) {
+				printf("column %d (%s) is %d wide, ", c+1, dbcolname(dbproc, c+1), colwidth(dbproc, c+1));
+				printf("buffer initialized to '%s'\n", bound_buffers[c]);
+			}
+			for( c=0; c < ncol && c < nbuf; c++ ) {
+				erc = dbbind(dbproc, c+1, STRINGBIND, 0, (BYTE *) bound_buffers[c]);
+				if (erc == FAIL) {
+					fprintf(stderr, "Failed line %d: dbbind\n", __LINE__);
+					exit(1);
+				}
+
+				printf("%-*s ", colwidth(dbproc, c+1), dbcolname(dbproc, c+1));
+			}
+			printf("\n");
+
 			while ((row_code = dbnextrow(dbproc)) != NO_MORE_ROWS) {
 				empty_resultset = 0;
 				if (row_code == REG_ROW) {
-					printf("\t%s\n", teststr);
+					int c;
+					for( c=0; c < ncol && c < nbuf; c++ ) {
+						printf("%-*s ", colwidth(dbproc, c+1), bound_buffers[c]);
+					}
+					printf("\n");
 				} else {
 					/* not supporting computed rows in this unit test */
 					failed = 1;
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 6c6b985..606f3fc 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.182 2008/02/20 08:04:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.183 2008/06/12 01:00:48 jklowden Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -2842,12 +2842,12 @@ tds_willconvert(int srctype, int desttype)
 	unsigned int i;
 	const ANSWER *p = NULL;
 
-	tdsdump_log(TDS_DBG_FUNC, "tds_willconvert()\n");
+	tdsdump_log(TDS_DBG_FUNC, "tds_willconvert(%d, %d)\n", srctype, desttype);
 
 	for (i = 0; i < sizeof(answers) / sizeof(ANSWER); i++) {
 		if (srctype == answers[i].srctype && desttype == answers[i].desttype) {
-			tdsdump_log(TDS_DBG_FUNC, "tds_willconvert() %d %d %d\n", answers[i].srctype, answers[i].desttype,
-				    answers[i].yn);
+			tdsdump_log(TDS_DBG_FUNC, "tds_willconvert(%d, %d) returns %s\n", answers[i].srctype, answers[i].desttype,
+				    answers[i].yn? "yes":"no");
 			p =  &answers[i];
 			break;
 		}

